#include "usr.h"
#include "app_baseinfo.h"
#include "hal_ble_client.h"
#include "hal_ble_host.h"
#include "bsp_time.h"
#include "hal_led.h"
#include "ble_gap.h"
#include "bsp_battery.h"
#include "drv_ms5611.h"

/*************************************************/
#define SHOES_NAME "SMART SHOE"
#define SHOES_NAME_LEN  64
#define HARDWARE_VERSION	0x0100
#define SOFTWARE_VERSION	0x0100
#define BASEINFOBUFF_LEN  80
static uint8_t baseinfoBuff[128];
static uint8_t basedata[16];

static uint8_t isGetClientInfo = 0;
void Host_GetClientInfo(void)
{
	static uint8_t buf[16];
	buf[0] = BLE_Host_T_UPDATE_BASEINFO;
	BLE_Host_Tx_Send(BLE_Host_T_UPDATE,buf,9,1,0,0,0);
}

void BASEINFO_HostGetClientData(void)
{
	static uint32_t tim=0;
	if(TIME_GetTicks()-tim>=10000){ tim = TIME_GetTicks();
		if(isGetClientInfo==0) Host_GetClientInfo();
	}
}

 //>> 0xA1: ѯ
void cb_BLE_Host_R_UPDATE(void* handle)
{
	BLE_Host_Rx_t *target = handle;
	uint8_t _cmd = target->pDat[0];
	switch(_cmd){
		case BLE_Client_R_UPDATE_BASEINFO:{
			//>> 0(豸Ϣ): ʼʱms(8)
			//<< 0(): 豸ͺ(64)+Ьַ(6)+Ӳ汾(2)+汾(2)+Ьַ(6)+Ӳ汾(6)+汾(2)
			//>> AA 06 F9 A1 00 4A
			//<< AA 55 AA A1 00 53 4D 41 52 54 20 53 48 4F 45 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 C1 EB D0 E3 87 47 01 00 01 00 00 00 00 00 00 4F
			BLE_Client_Tx_Send(BLE_Client_T_UPDATE,baseinfoBuff,BASEINFOBUFF_LEN,1,0,0,0);
			break;}
		case BLE_Client_R_UPDATE_DATA:{
			//>> 1(豸)
			//<< 1(): Ь(1)+Ь¶(1)+Ьѹ(4)+Ь(1)+Ь¶(1)+Ьѹ(4)
			//>> AA 06 F9 A1 01 4B
			//<< AA 12 ED A1 01 00 90 12 34 56 78 00 90 12 34 56 78 93

			break;}
		case BLE_Client_R_UPDATE_STEPNUM:{//>> 2: ѯ + 0 + byte[8]: ʱms + byte[1]:һķ 
								//	<< 2 + 0: ʼ + byte[8]: ʼʱms + byte[1]: 
								//		<< 2 + byte[1]:  + byte[4]: ÿСʱǰbyteΪbyteΪ룩 + byte[4]: ÿСʱǰbyteΪbyteΪ룩 + byte[4]: ÿСʱǰbyteΪbyteΪ룩 ..
								//			>> 2 + byte[1]: (ʾյ)
								//  	<< 2 + 2: byte[4]: ÿСʱ + byte[4]: ÿСʱ + byte[4]: ÿСʱ ..
								//			>> 2 + byte[1]: (ʾյ)..  ==  
			
			break;}
		default:break;
	}
}

void BASEINFO_SendUpdateData(void)
{
	//>> 1(豸)
	//<< 1(): Ь(1)+Ь¶(1)+Ьѹ(4)+Ь(1)+Ь¶(1)+Ьѹ(4)
	//>> AA 06 F9 A1 01 4B
	//<< AA 12 ED A1 01 00 90 12 34 56 78 00 90 12 34 56 78 93
	uint8_t L=0;
	int32_t temperature;
	uint32_t press;
	sd_temp_get(&temperature);
	temperature = temperature>>2; 
	press = MS5611_ReadPressure();
	DEBUG_LOG("temperature=%d\n",temperature);
	DEBUG_LOG("press=%d\n",press);
	temperature = 0x90;
	press = 0x12345678;
	
	//
	basedata[L++] = BLE_Client_T_UPDATE_DATA;
	//Ь
	basedata[L++] = ADC_GetBatteryPersent();
	basedata[L++] = (uint8_t)temperature;
	basedata[L++] = (uint8_t)(press>>24);
	basedata[L++] = (uint8_t)(press>>16);
	basedata[L++] = (uint8_t)(press>>8);
	basedata[L++] = (uint8_t)(press>>0);
	//Ь
	basedata[L++] = ADC_GetBatteryPersent();
	basedata[L++] = (uint8_t)temperature;
	basedata[L++] = (uint8_t)(press>>24);
	basedata[L++] = (uint8_t)(press>>16);
	basedata[L++] = (uint8_t)(press>>8);
	basedata[L++] = (uint8_t)(press>>0);
	BLE_Client_Tx_Send(BLE_Client_T_UPDATE,basedata,L,1,0,0,0);
}

 //>> 0xA1: ѯ
void cb_BLE_Client_R_UPDATE(void* handle)
{
	BLE_Client_Rx_t *target = handle;
	uint8_t _cmd = target->pDat[0];
	switch(_cmd){
		case BLE_Client_R_UPDATE_BASEINFO:{
			//>> 0(豸Ϣ): ʼʱms(8)
			//<< 0(): 豸ͺ(64)+Ьַ(6)+Ӳ汾(2)+汾(2)+Ьַ(6)+Ӳ汾(6)+汾(2)
			//>> AA 06 F9 A1 00 4A
			//<< AA 55 AA A1 00 53 4D 41 52 54 20 53 48 4F 45 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 C1 EB D0 E3 87 47 01 00 01 00 00 00 00 00 00 4F
			BLE_Client_Tx_Send(BLE_Client_T_UPDATE,baseinfoBuff,BASEINFOBUFF_LEN,1,0,0,0);
			break;}
		case BLE_Client_R_UPDATE_DATA:{
			//>> 1(豸)
			//<< 1(): Ь(1)+Ь¶(1)+Ьѹ(4)+Ь(1)+Ь¶(1)+Ьѹ(4)
			//>> AA 06 F9 A1 01 4B
			//<< AA 12 ED A1 01 00 90 12 34 56 78 00 90 12 34 56 78 93
			BASEINFO_SendUpdateData();
			break;}
		case BLE_Client_R_UPDATE_STEPNUM:{//>> 2: ѯ + 0 + byte[8]: ʱms + byte[1]:һķ 
								//	<< 2 + 0: ʼ + byte[8]: ʼʱms + byte[1]: 
								//		<< 2 + byte[1]:  + byte[4]: ÿСʱǰbyteΪbyteΪ룩 + byte[4]: ÿСʱǰbyteΪbyteΪ룩 + byte[4]: ÿСʱǰbyteΪbyteΪ룩 ..
								//			>> 2 + byte[1]: (ʾյ)
								//  	<< 2 + 2: byte[4]: ÿСʱ + byte[4]: ÿСʱ + byte[4]: ÿСʱ ..
								//			>> 2 + byte[1]: (ʾյ)..  ==  
			
			break;}
		default:break;
	}
}

void BASEINFO_Set(void)
{ //<< 0(豸Ϣ): 豸ͺ(64)+Ьַ(6)+Ӳ汾(2)+汾(2)+Ьַ(6)+Ӳ汾(6)+汾(2)
	ble_gap_addr_t mAddr;
	uint32_t err_code;
	uint8_t L = SHOES_NAME_LEN+1;
	memset(baseinfoBuff,0,sizeof(baseinfoBuff));
	//
	baseinfoBuff[0] = BLE_Client_T_UPDATE_BASEINFO;
	//豸
	for(int i=0;i<sizeof(SHOES_NAME);i++){
		baseinfoBuff[i+1] = SHOES_NAME[i];
	}
	//MAC ַ
	err_code = sd_ble_gap_addr_get(&mAddr); APP_ERROR_CHECK(err_code);
	DEBUG_LOG("mac addr:");for(int i=0;i<6;i++){DEBUG_LOG("%02X ",mAddr.addr[i]);}DEBUG_LOG("\n");
	for(int i=0;i<6;i++){
		baseinfoBuff[L++] = mAddr.addr[5-i];
	}
	//Ӳ汾
	baseinfoBuff[L++] = (uint8_t)((uint16_t)HARDWARE_VERSION>>8);
	baseinfoBuff[L++] = (uint8_t)((uint16_t)HARDWARE_VERSION>>0);
	//汾
	baseinfoBuff[L++] = (uint8_t)((uint16_t)SOFTWARE_VERSION>>8);
	baseinfoBuff[L++] = (uint8_t)((uint16_t)SOFTWARE_VERSION>>0);
}

void BASEINFO_Initialize(void)
{
	BASEINFO_Set();
	BLE_Client_Rx_Regist(BLE_Client_R_UPDATE,cb_BLE_Client_R_UPDATE);
	BLE_Host_Rx_Regist(BLE_Host_R_UPDATE,cb_BLE_Host_R_UPDATE);
	Process_Regist(BASEINFO_HostGetClientData);
	
}


