#ifndef __APP_FLASH_H__
#define __APP_FLASH_H__
/*************************************
 *INCLUDES
 */
#include "exception.h"
#include "app_power.h"
#include "nrf_gpio.h"
#include "nrf_delay.h"
#include "nrf_sdm.h"

//ERROR CODE
#define ZONE_OP_SUCCESS										0x00																//ZONEɹ
#define ZONE_ERROR_READ_FAIL							(ZONE_OP_SUCCESS+0x01)							//ȡʧ
#define ZONE_ERROR_WRITE_FAIL							(ZONE_OP_SUCCESS+0x02)							//дʧ
#define ZONE_ERROR_ERASE_FAIL							(ZONE_OP_SUCCESS+0x03)							//ʧ
#define ZONE_ERROR_ADDRESS_FAIL						(ZONE_OP_SUCCESS+0x04)							//ַԽ

/********************************************
*API FUCTIONS
*/
#define RecordMacAddrL 6 //ҪЬMACַ

#define LR_FLAG_VALUE  0x66
typedef struct __attribute__((packed,aligned(4))) _FlashBackup{
	uint32_t  head;	
	uint8_t 	macAddr_L[RecordMacAddrL];
	uint8_t 	macAddr_R[RecordMacAddrL];
	uint32_t 	hardVersion;
	uint16_t 	sotfVersion;
	uint8_t 	isConfig;
	uint8_t  	isHost;
	uint8_t   ErrStartCnt;
	uint8_t   RestartCnt;
	uint8_t   LR_FLAG;
}FlashBackup_t;

//size:36
typedef struct _FlashStep{
	uint8_t 	startTime[8];		   //ǰʱ
	uint32_t 	stepCur[2];				 //ǰò
	uint32_t 	step[2];					 //ÿСʱ¼Ьò01
	uint32_t 	step_num;					 //Ѿ¼ÿСʱ
}FlashStep_t;
//size:12
typedef struct _FlashClient{
	uint8_t 	isConfig;
	uint32_t 	hardVersion;
	uint16_t 	sotfVersion;
	uint8_t	 	macAddr[RecordMacAddrL];
}FlashClient_t;
//size:
typedef struct _FlashLog{
	uint8_t Errorflag;
	uint8_t logData[50];
}FlashLog;
//size:64
typedef struct _Flash_Param{
  uint32_t      head;	
	uint8_t  			isHost;
	uint8_t       LR_FLAG;
	uint8_t 			macHost[RecordMacAddrL];
	FlashStep_t 	mStep;
	FlashClient_t mClient;
	FlashLog 			mFlashLog;
	battercb_t 		mbattercb_t;
}Flash_t;

extern Flash_t mFlash;
extern FlashBackup_t 	mBackup;

/*1.APIɵݵʱAPIĲĬֵ䣬дصʱAPIĸʽдءݣ
  2.APIݣԼʶǶbuffҪдصʱ򣬽buffԭmemcpyǰݣûʵ֣
*/
 
/********************************************
 *API FUCTIONS
 */
void Flash_Initialize(void);
//洢
uint32_t Flash_SaveStep(void);
//ȡ׵ַ
uint32_t Flash_GetStepZoneStartAddr(void);

//ɾв
uint32_t Flash_DeleteAllStep(void);
//ɾinformation
uint32_t Flash_DeleteAllInfor(void);

uint32_t Flash_DeleteAllBackup(void);
	
uint32_t Flash_GetBackup(FlashBackup_t *pbackup);

uint32_t Flash_SaveBackup(void);
	
//洢Ϣ
uint32_t Flash_SaveInfomation(void);
//ȡŲʼַ
uint32_t flash_GetStep_StartAddress(void);
//ȡָflash
uint32_t flash_Data_Read(uint32_t addr, uint32_t *pData, uint32_t dataLen);
//־Ϣ
uint32_t Flash_SaveLog(uint32_t id, uint32_t pc, uint32_t info);

//Խӿ
//void TestHalFlashInterface(void);

void flash_SetClearStepFlag(void);

#endif





























