#ifndef __EXCEPTION_H__
#define __EXCEPTION_H__

#ifdef __cplusplus
extern "C" {
#endif

/*Includes ------------------------------------------------------*/
#include <stdint.h>
#include <stdbool.h>

/*STRUCTION -----------------------------------------------------*/

typedef struct 
{
	float preBestResult_Voltage2power ;
	float preBestResult_chargeV2P_f ;
	float P_mAh ;
	float kg ;
	float P2 ;
	float P1 ;
	float Battery_capacity_mAh ;
	float adc_tp4056_power ;
	char init;
	char  sta ;	
	char chargeV2P_f_init;
	char Voltage2power_init;
} battercb_t;

typedef enum {
	//쳣
	EXCEPT_DATA_BACK_MAG =0,				//쳣  ŵش
	EXCEPT_DATA_FRONT_ACC,					//쳣  ǰżٶ
	EXCEPT_DATA_FRONT_GRY,					//쳣  ǰ
	EXCEPT_DATA_FRONT_MAG,					//쳣  ǰŵش
	EXCEPT_DATA_CHARGE,							//쳣  
	EXCEPT_DATA_BATTERY,						//쳣  
	EXCEPT_IMU_SUSPEND_OVERFLOW,		//쳣  쳣ģʽ
	EXCEPT_ANT_DAMAGE,							//쳣  
	EXCEPT_FLASH,		                //쳣  FLASH
	EXCEPT_GAME,		                //쳣  Ϸģʽ
	EXCEPT_RealStep,                //쳣  ʵʱŲ쳣
	EXCEPT_DATEStep,                //쳣  ճŲ쳣
	EXCEPT_Pair,                    //쳣  쳣
	EXCEPT_Power,                   //쳣  ͹
	EXCEPT_DFU,                     //쳣  Զ쳣
	EXCEPT_CONNET,		              //쳣  Ь
	EXCEPT_OVERTURAN,               //쳣  ת鿴쳣
	EXCEPT_UNKOWN_RESET,						//쳣  δ֪
	EXCEPT_ADC_INIT,								//쳣  adcʼʧ
	EXCEPT_SPI_INIT,								//쳣  spiʼʧ
	EXCEPT_SPI_RW,									//쳣  spiдʧ
	EXCEPT_IIC_RW,									//쳣  IICдʧ
	EXCEPT_FLASH_INIT,							//쳣  flashʼʧ
	EXCEPT_PWM_INIT,								//쳣  pwmʼʧ
	EXCEPT_WDT_INIT,								//쳣  wdtʼʧ
	EXCEPT_RTC_INIT,								//쳣  rtcʼʧ
	EXCEPT_RTC_CONFIG,							//쳣  rtcʧ
	EXCEPT_EXCEPTION,			          //쳣  쳣
	EXCEPT_QMA7981,                 //쳣  QMA7981
	EXCEPT_NUM,                     //쳣  쳣
}ExcepType_t;

/*API -------------------------------------------------------*/
void Exception_Init(void);

void Except_SetExceptype(ExcepType_t excep_type);

void Except_ClearExceptype(ExcepType_t excep_type);

bool Except_IsError(ExcepType_t excep_type);

int  Except_TxError(ExcepType_t excep_type,const char *errstr);

void Except_Get_Cur_Porcess_ID(uint32_t cur_process_id);

void Except_Get_End_Porcess_ID(uint32_t end_process_id);

void Except_Unkown_Reset_WDT_Set(void);

int Except_Display(ExcepType_t excep_type,const char *errstr);

/**
	@brief 		ȡ¼ַ
	@return   ¼ַ
*/
battercb_t* Except_Get_Battery_Record_Buff(void);

#ifdef __cplusplus
}
#endif

#endif












