/*Includes ----------------------------------------------*/
#include "tool.h"
#include "hal_MahonyAHRS.h"
#include "ble_comm.h"
#include "nrf_delay.h"
#include "bsp_pwm.h"
#include "bsp_time.h"
#include "fml_adc.h"
#include "bsp_wdt.h"
#include "exception.h"
#include "selfcheck.h"
#include "system.h"
#include "drv_qma7981.h"
#include "hal_led.h"
#include "hal_battery.h"
#include "bll_imu.h"
#include "app_flash.h"
#include "system.h"
#include "hal_mahonyAHRS.h"
#include "app_detectIsHost.h"

/*Private macro ------------------------------------------------------------------------------------------------------------------------------------*/

#define	SELFCHECK_SCAN_DEVICE_RSSI_MIN_THRESHOLD					                     -60																								//Ҫɨ豸RSSIСֵ-76

#define	SELFCHECK_CHARGE_CHIP_PIN_ADC_MIN_THRESHOLD				                     80																									//оƬŵСADCֵ

#define	SELFCHECK_BATTERY_PIN_ADC_MIN_THRESHOLD						                     3300																								//طѹСADCֵ

#define	SELFCHECK_BATTERY_PIN_ADC_MAX_THRESHOLD						                     4300																								//طѹADCֵԭʼֵΪ3721Ϊ5.49V

#define SELFCHECK_MIDDLE_ACC_PROS_ROLL_MIN_THRESHOLD													 0																									//мٶROLLֵСֵ

#define	SELFCHECK_MIDDLE_ACC_PROS_ROLL_MAX_THRESHOLD													 35																									//мٶROLLֵֵ

#define SELFCHECK_MIDDLE_ACC_CONS_ROLL_MIN_THRESHOLD													 160																								//мٶȷROLLֵСֵ

#define	SELFCHECK_MIDDLE_ACC_CONS_ROLL_MAX_THRESHOLD													 180																								//мٶȷROLLֵֵ

#define SELFCHECK_WEAR_INSOLE_MAG_NORM_MIN_THRESHOLD													 5000																								//ЬĵشnormֵСֵ

#define	SELFCHECK_SENSOR_MAG_SHAKE_TRIGGER_THRESHOLD													 18000																							//شŶ

#define SELFCHECK_SENSOR_MAG_NO_WELDING_CAPACITOR_MIN_THRESHOLD								 200																								//شŴûӵݵСֵ

#define	SELFCHECK_SENSOR_MAG_SHAKE_THRESHOLD																	 200																								//شŶֵ

#define	SELFCHECK_LED_DISPLAY_CYCLE_THRESHOLD																	 200																								//Լʾʱ䣬λms

#define	SELFCHECK_MIDDLE_ACC_CHECK_MT_MIN_THRESHOLD														 1500																								//мٶȼСֵ,𶯵Ĳֵ129,и𶯵Ĳֵ1800+

#define SELFCHECK_IMU_MONITOR_DATA_ERR_SUM_MAX																 416																								//ݼۼֵ


/*STRUCTION ------------------------------------------------------------------------------------------------------------------------------------*/
typedef enum {
	SELFCHECK_RESULT_SUCCESS = 0,																																																		//Լɹ
	
	SELFCHECK_RESULT_ERR_FRONT_SENSOR_CONFIG_SIX_AXIS_ID,																																						//ԼʧܡǰŴID
	
	SELFCHECK_RESULT_ERR_FRONT_SENSOR_CONFIG_MAG_ID,																																								//ԼʧܡǰŴõشID
	
	SELFCHECK_RESULT_ERR_BACK_SENSOR_CONFIG_ID,																																											//ԼʧܡŴõشID
	
	SELFCHECK_RESULT_ERR_CHARGE_CHIP_PIN_ADC,																																												//ԼʧܡоƬADC
	
	SELFCHECK_RESULT_ERR_BATTERY_PIN_ADC,																																														//ԼʧܡطѹADC
	
	SELFCHECK_RESULT_ERR_RSSI,																																																			//ԼʧܡRSSI
	
	SELFCHECK_RESULT_ERR_MT,																																																				//Լʧܡ𶯵
	
	SELFCHECK_RESULT_ERR_FRONT_IMU_REVERSE,																																													//ԼʧܡǰŴװ
	
	SELFCHECK_RESULT_ERR_FRONT_MAG_DATA_TO_SMALL,																																										//ԼʧܡǰŴشݹС
	
	SELFCHECK_RESULT_ERR_FRONT_MAG_DATA_SHAKE,																																											//ԼʧܡǰŴشݶ
	
	SELFCHECK_RESULT_ERR_BACK_DATA_TO_SMALL,																																												//ԼʧܡŴشݹС
	
	SELFCHECK_RESULT_ERR_BACK_DATA_SHAKE,																																														//ԼʧܡŴشݶ
	
	SELFCHECK_RESULT_ERR_FRONT_SENSOR_CONFIG_SIX_AXIS,																																							//ԼʧܡǰŴ
	
	SELFCHECK_RESULT_ERR_FRONT_SENSOR_CONFIG_MAG,																																										//ԼʧܡǰŴõش
	
	SELFCHECK_RESULT_ERR_FRONT_SIX_AXIS_NO_DATA,																																										//ԼʧܡǰŴû
	
	SELFCHECK_RESULT_ERR_FRONT_SIX_AXIS_EXCP_DATA,																																									//ԼʧܡǰŴ쳣(ݳ)
	
	SELFCHECK_RESULT_ERR_FRONT_MAG_NO_DATA,																																													//ԼʧܡǰŴشû
	
	SELFCHECK_RESULT_ERR_FRONT_MAG_EXCP_DATA,																																												//ԼʧܡǰŴش쳣(ݳ)
	
	SELFCHECK_RESULT_ERR_BACK_SENSOR_CONFIG,																																												//ԼʧܡŴ
	
	SELFCHECK_RESULT_ERR_BACK_NO_DATA,																																															//ԼʧܡŴû
	
	SELFCHECK_RESULT_ERR_BACK_EXCP_DATA,																																														//ԼʧܡŴ쳣(ݳ)
	
	SELFCHECK_RESULT_ERR_MIDDLE_SENSOR_CONFIG,																																											//Լʧܡм䴫
	
	SELFCHECK_RESULT_ERR_MIDDLE_NO_DATA_OR_EXCP_DATA,																																								//Լʧܡм䴫ûݻ쳣
	
} SELFCHECK_RESULT_e;

typedef struct _selfcheck
{
	uint32_t																  			  selfcheck_result;																															//Լ
	
	uint32_t     																			selfcheck_result_led_color;																										//Լledɫ
	
	uint32_t																					selfcheck_result_flash_num;																										//Լ˸
	
	int16_t 																					max_rssi;																																			//RSSIֵ
	
	fml_imu_data_t 																		f_data;																																				//ǰŴ
	
	fml_imu_data_t 																		b_data;																																				//Ŵ
	
	qma_data_t 																				m_data;																																				//м䴫
	
	bool																							f_is_read_data;																																//ǰŴǷݱ־λ
	
	bool																						  b_is_read_data;																																//ŴǷݱ־λ
	
	char 																							order;																																				//ָ
	
} SelfCheck_t;

/*Local Variable ------------------------------------------------------------------------------------------------------------------------------------*/
static SelfCheck_t ob_selfcheck;

static const bll_imu_one_way_param_t game_front_param={
	.acc_power_mode 						= FML_IMU_ACC_POWER_MODE_NORMAL,						//ǰ - ٶģʽ
	.gry_power_mode 						= FML_IMU_GRY_POWER_MODE_NORMAL,						//ǰ - ģʽ
	.timestamp_resolution 			= FML_IMU_TIMESTAMP_25US,										//ǰ - ʱ25US
	.timestamp_switch 					= FML_IMU_TIMESTAMP_ON,											//ǰ - ʱ
	.acc_fs 										= FML_IMU_ACC_FS_16G,												//ǰ - ٶ - 16G
	.gry_fs 										= FML_IMU_GRY_FS_2000DPS,										//ǰ -  - 2000DPS
	.mag_fs 										= FML_IMU_MAG_FS_30GS,											//ǰ - شż - 30GS
	.acc_odr 									  = FML_IMU_ACC_ODR_416HZ,										//ǰ - ٶȲƵ - 104HZ
	.gry_odr 									  = FML_IMU_GRY_ODR_416HZ,										//ǰ - ǲƵ - 104HZ
	.mag_odr 									  = FML_IMU_MAG_ODR_200HZ,										//ǰ - شżƲƵ - 200HZ
	.fifo_odr 									= FML_IMU_FIFO_ODR_416HZ,	
};

static const bll_imu_one_way_param_t game_back_param={
	.acc_power_mode 						= FML_IMU_ACC_POWER_MODE_NORMAL,						// - ٶģʽ
	.gry_power_mode 						= FML_IMU_GRY_POWER_MODE_NORMAL,						// - ģʽ
	.timestamp_resolution 			= FML_IMU_TIMESTAMP_25US,										// - ʱ25US
	.timestamp_switch 					= FML_IMU_TIMESTAMP_OFF,										// - ʱر
	.acc_fs 										= FML_IMU_ACC_FS_16G,											  // - ٶ - 16G
	.gry_fs 										= FML_IMU_GRY_FS_2000DPS,										// -  - 2000DPS
	.mag_fs 										= FML_IMU_MAG_FS_30GS,											// - شż - 30GS
	.acc_odr 										= FML_IMU_ACC_ODR_OFF,											// - ٶȲƵ - ر
	.gry_odr 										= FML_IMU_GRY_ODR_OFF,											// - ǲƵ - ر
	.mag_odr 										= FML_IMU_MAG_ODR_200HZ,										// - شżƲƵ - 200HZ
	.fifo_odr 									= FML_IMU_FIFO_ODR_OFF,	
};

static const bll_imu_param_t game_bll_imu_param_t={
	.config_param[FML_IMU_DIR_FRONT] = &game_front_param,
	.config_param[FML_IMU_DIR_BACK] =  &game_back_param,
};

static MahonyAHRS_t Self_Mind_Mahony={0};
static MahonyAHRS_t Self_Front_Mahony={0};


/*Local Functions ------------------------------------------------------------------------------------------------------------------------------------*/
static void monitor_sensor_data(int16_t *f_acc, int16_t *f_gry, int16_t *f_mag, int16_t *b_mag)
{
	static int16_t 																last_f_acc[3];																								//һεǰżٶֵ
	
	static int16_t 																last_f_gry[3];																								//һεǰֵ
	
	static int16_t 																last_f_mag[3];																								//һεǰŵشżֵ
	
	static int16_t 																last_b_mag[3];																								//һεĺŵشżֵ	
	
	static int16_t																last_f_acc_err_sum;																						//һεǰżٶֵۼ
	
	static int16_t 																last_f_gry_err_sum;																						//һεǰֵۼ
	
	static int16_t 																last_f_mag_err_sum;																						//һεǰŵشżֵۼ
	
	static int16_t 																last_b_mag_err_sum;																						//һεĺŵشżֵۼ
	
	/*ǰżٶ*/
	if(f_acc != NULL)
	{
		if(
				last_f_acc[0] == f_acc[0] && \
				last_f_acc[1] == f_acc[1] && \
				last_f_acc[2] == f_acc[2]
			)
		{
			last_f_acc_err_sum++;
			
			if(last_f_acc_err_sum >= SELFCHECK_IMU_MONITOR_DATA_ERR_SUM_MAX){
				ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_SIX_AXIS_EXCP_DATA);
			}
			
		}else{
			last_f_acc_err_sum = 0;
		}
		
		last_f_acc[0] = f_acc[0];
		last_f_acc[1] = f_acc[1];
		last_f_acc[2] = f_acc[2];
	}
	/*ǰ*/
	if(f_gry != NULL)
	{
		if(
				last_f_gry[0] == f_gry[0] && \
				last_f_gry[1] == f_gry[1] && \
				last_f_gry[2] == f_gry[2]
			)
		{
			last_f_gry_err_sum++;
			
			if(last_f_gry_err_sum >= SELFCHECK_IMU_MONITOR_DATA_ERR_SUM_MAX){
				ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_SIX_AXIS_EXCP_DATA);
			}
				
		}else{
			last_f_gry_err_sum = 0;
		}
		
		last_f_gry[0] = f_gry[0];
		last_f_gry[1] = f_gry[1];
		last_f_gry[2] = f_gry[2];
	}
	/*ǰŵشż*/
	if(f_mag != NULL)
	{
		if(
				last_f_mag[0] == f_mag[0] && \
				last_f_mag[1] == f_mag[1] && \
				last_f_mag[2] == f_mag[2]
			)
		{
			last_f_mag_err_sum++;
			
			if(last_f_mag_err_sum >= SELFCHECK_IMU_MONITOR_DATA_ERR_SUM_MAX){
				ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_MAG_EXCP_DATA);
			}
				
		}else{
			last_f_mag_err_sum = 0;
		}
		
		last_f_mag[0] = f_mag[0];
		last_f_mag[1] = f_mag[1];
		last_f_mag[2] = f_mag[2];
	}
	/*ŵشż*/
	if(b_mag != NULL)
	{
		if(
				last_b_mag[0] == b_mag[0] && \
				last_b_mag[1] == b_mag[1] && \
				last_b_mag[2] == b_mag[2]
			)
		{
			last_b_mag_err_sum++;
			
			if(last_b_mag_err_sum >= (SELFCHECK_IMU_MONITOR_DATA_ERR_SUM_MAX/2)){
				ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_BACK_EXCP_DATA);
			}
				
		}else{
			last_b_mag_err_sum = 0;
		}
		
		last_b_mag[0] = b_mag[0];
		last_b_mag[1] = b_mag[1];
		last_b_mag[2] = b_mag[2];
	}
}
static void fb_data_notify_cb(uint32_t dir_bit)
{
	int data_len;

	if((dir_bit >> BLL_IMU_DIR_FRONT) & 0x01)
	{
		memset(&ob_selfcheck.f_data,0,sizeof(ob_selfcheck.f_data));
		data_len = bll_imu_get_data_num(BLL_IMU_DIR_FRONT);
		for(int i=0; i<data_len;i++)
		{
			bll_imu_get_data(BLL_IMU_DIR_FRONT, i, &ob_selfcheck.f_data);
		}
		monitor_sensor_data(ob_selfcheck.f_data.acc, ob_selfcheck.f_data.gry, ob_selfcheck.f_data.mag, NULL);
		Mahony_update(&Self_Front_Mahony,0,0,0,ob_selfcheck.f_data.acc[0],ob_selfcheck.f_data.acc[1],ob_selfcheck.f_data.acc[2],0,0,0);
	}
	
	if((dir_bit >> BLL_IMU_DIR_BACK) & 0x01)
	{
		memset(&ob_selfcheck.b_data,0,sizeof(ob_selfcheck.b_data));
		data_len = bll_imu_get_data_num(BLL_IMU_DIR_BACK);
		for(int i=0; i<data_len;i++)
		{
			bll_imu_get_data(BLL_IMU_DIR_BACK, i, &ob_selfcheck.b_data);
		}
		monitor_sensor_data(NULL, NULL, NULL, ob_selfcheck.b_data.mag);
	}
	
	if(((dir_bit >> BLL_IMU_DIR_FRONT) & 0x01))
	{
		 ob_selfcheck.f_is_read_data = true;
	}

	
	if((dir_bit >> BLL_IMU_DIR_BACK))
	{
		ob_selfcheck.b_is_read_data = true;
	}
	
}

static void scan_report_cb(ble_gap_evt_adv_report_t const * p_adv_report)
{
	ob_selfcheck.max_rssi = (ob_selfcheck.max_rssi > p_adv_report->rssi)?ob_selfcheck.max_rssi:p_adv_report->rssi;
}

static void selfcheck_result_display_process(void)
{
	static uint32_t led_display_count = 0;
	
	//Լʾ
	//ǰŴɫǰ˸1£ǰŵش˸2£ǰݶȡʧܻ쳣˸3£ǰŵشݶȡʧܻ쳣˸4£
	//Ŵɫŵش˸5£ŵشݶȡʧܻ쳣˸6£
	//м䴫ɫмٶ˸7£ٶrollֵڷΧ˸8£
	//оƬ͵طѹrssiɫоƬ˸9£طѹ˸10£rssi˸11£
	//мٶȼ𶯵
	//ͨɫ1ڣ500ms500ms𣨶ϵԴߣ⵽Ь棬ɫ1ڣ500ms500ms𣨶ϵԴߣ 
	//LEDԴߣ͡4ڣ40ms160ms𣨶ϵԴߣһ飩
	
	//ι
	feed_watchdog();
	
	Process_UpdatePeroid(selfcheck_result_display_process,SELFCHECK_LED_DISPLAY_CYCLE_THRESHOLD);
	
	led_display_count++;
	
	if(led_display_count % 2 == 0)
	{
		WS2812_DisplayDot(COLOR_BLACK);WS2812_Pwm_Play();
	}
	else
	{
		WS2812_DisplayDot(ob_selfcheck.selfcheck_result_led_color);WS2812_Pwm_Play();
	}
	if(led_display_count >= ob_selfcheck.selfcheck_result_flash_num * 2)
	{
		led_display_count = 0;
		WS2812_DisplayDot(COLOR_BLACK);WS2812_Pwm_Play();
		Process_UpdatePeroid(selfcheck_result_display_process,SELFCHECK_LED_DISPLAY_CYCLE_THRESHOLD * 3);
	}
}

static void selfcheck_led_process(void)
{
	//ι
	feed_watchdog();	
	
	static uint8_t flow = 0;
	
	switch(flow)
	{
		case 0:
			WS2812_DisplayDot(COLOR_RED);WS2812_Pwm_Play();
			flow = 1;
			break;
		case 1:
			WS2812_DisplayDot(COLOR_GREEN);WS2812_Pwm_Play();
			flow = 2;
			break;
		case 2:
			WS2812_DisplayDot(COLOR_BLUE);WS2812_Pwm_Play();
			flow = 0;
			break;
	}
	
	nrf_gpio_pin_write(PIN_MT_EN,1);//200msʱȡֹ״̬µмaccz
}

static void selfcheck_mt_process(void)
{
	static int16_t	max_acc_z = 0;
	static int16_t	min_acc_z = 32767;
	int16_t	acc_z = 0;
	
	//ι
	feed_watchdog();	
	
	//Ƿ
	//ȡм䴫ݣٶrollֵ
	if(ob_selfcheck.order == 0x52)
	{
		memset(&ob_selfcheck.m_data,0,sizeof(ob_selfcheck.m_data));
		if(drv_qma_get_acc_data(&ob_selfcheck.m_data) == 0)
		{
			if(ob_selfcheck.m_data.acc[0]==0 && ob_selfcheck.m_data.acc[1]==0 && ob_selfcheck.m_data.acc[2]==0)return;
			if(ob_selfcheck.m_data.acc[0]==-1 && ob_selfcheck.m_data.acc[1]==-1 && ob_selfcheck.m_data.acc[2]==-1)return;

			if(ob_selfcheck.m_data.acc[2] < 0)acc_z = ob_selfcheck.m_data.acc[2]*-1;
			else acc_z = ob_selfcheck.m_data.acc[2];
			
			max_acc_z = (max_acc_z > acc_z)?max_acc_z:acc_z;
			
			min_acc_z = (min_acc_z > acc_z)?acc_z:min_acc_z;

			if((max_acc_z - min_acc_z) < SELFCHECK_MIDDLE_ACC_CHECK_MT_MIN_THRESHOLD)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_MT);
			else ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_MT);

//			SEGGER_RTT_printf(0,"middle acc %d,%d,%d acc_z:%d,max:%d,min:%d,%d\r\n",ob_selfcheck.m_data.acc[0],ob_selfcheck.m_data.acc[1],ob_selfcheck.m_data.acc[2],acc_z,max_acc_z,min_acc_z,max_acc_z-min_acc_z);
		}
	}
}

#define	N	10			//N > 3
int data[N];
int middleFilter(int in_data)
{
	int sum = 0;
	int temp[N];
	int change;
	int i,j;
	//¼
	for(i=0; i<(N-1); i++)
	{
		data[i]=data[i+1];
	}
	data[N-1] = in_data;
	//
	for(i=0; i<N; i++)
		temp[i] = data[i];
	//ðݷ
	for(i=1; i<N; i++)
		for(j=0; j<N-i; j++)
		{
			if(temp[i] > temp[i+1])
			{
				change = temp[i];
				temp[i] = temp[i+1];
				temp[i+1] = change;
			}
		}
	//
	for(i=1; i<(N-1); i++)
		sum = sum + temp[i];
	//ƽֵ
	return(sum/((N-2)));
 
}

static void selfcheck_process(void)
{
	BLL_IMU_CONFIG_RESULT  	f_config_result,b_config_result;
	int16_t									adc_value = 0;
	uint16_t 								front_mag_norm;
	uint16_t 								back_mag_norm;
	int16_t 								roll;
	uint8_t 								buf[256];
	uint8_t 								L=0;
	char 										mac_buf[16];	
	static uint32_t					charge_chip_adc_max = 0;
	static int16_t					battery_adc_max = 0;
	static uint32_t 				t_count = 0;
	static uint32_t					battery_adc_t_count = 0;
	static uint32_t					roll_t_count = 0;
	static uint32_t         sensor_t_count = 0;
	static uint32_t					last_tim = 0;
	static uint32_t					continue_trigger = 0;
	static uint32_t					front_mag_norm_max = 0;
	static uint32_t					back_mag_norm_max = 0;
	static uint32_t					front_mag_norm_min = 0xffffffff;
	static uint32_t					back_mag_norm_min = 0xffffffff;
	static bool							front_mag_shake_trigger = false;
	static bool							back_mag_shake_trigger = false;

	t_count++;
	
	//ι
	feed_watchdog();
	
	//ȡм䴫ݣٶrollֵ
	memset(&ob_selfcheck.m_data,0,sizeof(ob_selfcheck.m_data));
	if(drv_qma_get_acc_data(&ob_selfcheck.m_data) != 0)
	{
		ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_MIDDLE_NO_DATA_OR_EXCP_DATA);
		//
		drv_qma_set_acc_odr(QMA_ACC_ODR_104HZ);		
	}
	
	Mahony_update(&Self_Mind_Mahony,0,0,0,ob_selfcheck.m_data.acc[0],ob_selfcheck.m_data.acc[1],ob_selfcheck.m_data.acc[2],0,0,0);
	
	
	//ɸѡĵطѹĵѹ
	fml_adc_get_value(PIN_ADC_BAT_CHANNEL,&adc_value);
	adc_value = ADC_RESULT_IN_MILLI_VOLTS(adc_value) * 5 / 3;
	battery_adc_max = middleFilter(adc_value);
	
	//ÿ3ȡADC5VѹԵطѹǷ񺸽ӣֵԼ
	if(t_count - battery_adc_t_count > (3000/100))
	{
		if(!(SELFCHECK_BATTERY_PIN_ADC_MIN_THRESHOLD < battery_adc_max && battery_adc_max < SELFCHECK_BATTERY_PIN_ADC_MAX_THRESHOLD))ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_BATTERY_PIN_ADC);
		else ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_BATTERY_PIN_ADC);
		//¼ʱ
		battery_adc_t_count = t_count;
	}
	
	//оƬ
	fml_adc_get_value(PIN_ADC_CHARGMEASURE_CHANNEL,&adc_value);
	if(SELFCHECK_CHARGE_CHIP_PIN_ADC_MIN_THRESHOLD < adc_value)
	{
		charge_chip_adc_max++;
	}
	if(charge_chip_adc_max >= 5)
	{
		ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_CHARGE_CHIP_PIN_ADC);
	}
	else
	{
		ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_CHARGE_CHIP_PIN_ADC);
	}
	
	

	//ÿ3ٶrollֵԼ
	if(t_count - roll_t_count > (3000/100))
	{
		roll  = (int16_t)(Self_Mind_Mahony.roll*100);
		if(roll < 0)roll *= -1;
		roll = (roll > 0 && roll < 100)?1:roll/100;
		if(!( \
		(SELFCHECK_MIDDLE_ACC_PROS_ROLL_MIN_THRESHOLD < roll && roll < SELFCHECK_MIDDLE_ACC_PROS_ROLL_MAX_THRESHOLD) || \
		(SELFCHECK_MIDDLE_ACC_CONS_ROLL_MIN_THRESHOLD < roll && roll < SELFCHECK_MIDDLE_ACC_CONS_ROLL_MAX_THRESHOLD) \
		))ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_MIDDLE_NO_DATA_OR_EXCP_DATA);
		else
			ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_MIDDLE_NO_DATA_OR_EXCP_DATA);
		//¼ʱ
		roll_t_count = t_count;
	}

	//ÿ1鿴ǰ󴫸ǷҶȡɹҪ1нֵǷشûкӵݣԼ
	if(t_count - sensor_t_count > (1000/100))
	{
		//ǰŴж
		f_config_result = bll_imu_query_config_param_is_ready(BLL_IMU_DIR_FRONT,&game_bll_imu_param_t);
		if(f_config_result != BLL_IMU_CONFIG_FINISH)
		{
			if(f_config_result == BLL_IMU_CONFIG_FAIL_FRONT_SIX_AXIS_GET_ID)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_SENSOR_CONFIG_SIX_AXIS_ID);
			if(f_config_result == BLL_IMU_CONFIG_FAIL_FRONT_MAG_GET_ID)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_SENSOR_CONFIG_MAG_ID);
			if(f_config_result == BLL_IMU_CONFIG_FAIL_FRONT_MAG)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_SENSOR_CONFIG_MAG);
			if(f_config_result == BLL_IMU_CONFIG_FAIL_FRONT_SIX_AXIS)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_SENSOR_CONFIG_SIX_AXIS);
		}
		else
		{
			//û
			ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_FRONT_SENSOR_CONFIG_MAG);
			ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_FRONT_SENSOR_CONFIG_SIX_AXIS);
			
			if(ob_selfcheck.f_is_read_data != true)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_SIX_AXIS_NO_DATA);
			else
			{
				//û
				ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_FRONT_SIX_AXIS_NO_DATA);
				ob_selfcheck.f_is_read_data = false;
				
				front_mag_norm = sqrt((double)(ob_selfcheck.f_data.mag[0]*ob_selfcheck.f_data.mag[0]) + (double)(ob_selfcheck.f_data.mag[1]*ob_selfcheck.f_data.mag[1]) + (double)(ob_selfcheck.f_data.mag[2]*ob_selfcheck.f_data.mag[2]));
					
				//ǰŴشûӵ
				if(front_mag_norm < SELFCHECK_SENSOR_MAG_NO_WELDING_CAPACITOR_MIN_THRESHOLD)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_MAG_DATA_TO_SMALL);
				else ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_FRONT_MAG_DATA_TO_SMALL);
			}
		}
		
		
		//Ŵж
		b_config_result = bll_imu_query_config_param_is_ready(BLL_IMU_DIR_BACK,&game_bll_imu_param_t);
		if(b_config_result != BLL_IMU_CONFIG_FINISH)
		{
			if(b_config_result == BLL_IMU_CONFIG_FAIL_BACK_MAG_GET_ID)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_BACK_SENSOR_CONFIG_ID);
			else ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_BACK_SENSOR_CONFIG);
		}
		else 
		{
			//û
			ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_BACK_SENSOR_CONFIG);
			
			if(ob_selfcheck.b_is_read_data != true)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_BACK_NO_DATA);
			else
			{
				//û
				ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_BACK_NO_DATA);
				ob_selfcheck.b_is_read_data = false;
				
				back_mag_norm = sqrt((double)(ob_selfcheck.b_data.mag[0]*ob_selfcheck.b_data.mag[0]) + (double)(ob_selfcheck.b_data.mag[1]*ob_selfcheck.b_data.mag[1]) + (double)(ob_selfcheck.b_data.mag[2]*ob_selfcheck.b_data.mag[2]));
					
				//Ŵشûӵ
				if(back_mag_norm < SELFCHECK_SENSOR_MAG_NO_WELDING_CAPACITOR_MIN_THRESHOLD)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_BACK_DATA_TO_SMALL);
				else ob_selfcheck.selfcheck_result &= ~(1 << SELFCHECK_RESULT_ERR_BACK_DATA_TO_SMALL);
			}
			
		}

		//⴫ʧܣ
		if(f_config_result != BLL_IMU_CONFIG_FINISH || b_config_result != BLL_IMU_CONFIG_FINISH || ob_selfcheck.b_is_read_data != true || ob_selfcheck.f_is_read_data != true)
		{
			bll_imu_Resume_config_param(&game_bll_imu_param_t);
		}

		//¼ʱ-
		sensor_t_count = t_count;
	}
	
	//ڶ֮ǰŵشżⶶ
	if(t_count > (2000/100))
	{
		front_mag_norm = sqrt((double)(ob_selfcheck.f_data.mag[0]*ob_selfcheck.f_data.mag[0]) + (double)(ob_selfcheck.f_data.mag[1]*ob_selfcheck.f_data.mag[1]) + (double)(ob_selfcheck.f_data.mag[2]*ob_selfcheck.f_data.mag[2]));
		back_mag_norm = sqrt((double)(ob_selfcheck.b_data.mag[0]*ob_selfcheck.b_data.mag[0]) + (double)(ob_selfcheck.b_data.mag[1]*ob_selfcheck.b_data.mag[1]) + (double)(ob_selfcheck.b_data.mag[2]*ob_selfcheck.b_data.mag[2]));
		
		if(front_mag_norm >= SELFCHECK_SENSOR_MAG_SHAKE_TRIGGER_THRESHOLD)
		{
			//get max
			front_mag_norm_max = (front_mag_norm_max > front_mag_norm)?front_mag_norm_max:front_mag_norm;
			//get min
			front_mag_norm_min = (front_mag_norm_min > front_mag_norm)?front_mag_norm:front_mag_norm_min;
			
			front_mag_shake_trigger = true;
		}
		
		if(back_mag_norm >= SELFCHECK_SENSOR_MAG_SHAKE_TRIGGER_THRESHOLD)
		{
			//get max
			back_mag_norm_max = (back_mag_norm_max > back_mag_norm)?back_mag_norm_max:back_mag_norm;
			//get min
			back_mag_norm_min = (back_mag_norm_min > back_mag_norm)?back_mag_norm:back_mag_norm_min;
			
			back_mag_shake_trigger = true;
		}

		
//		SEGGER_RTT_printf(0,"front_mag_norm_max:%d,%d,%d,%d,%d,%d,%d,%d,%d,%d\r\n",front_mag_norm,back_mag_norm,front_mag_norm_max,back_mag_norm_max, \
//		                                                                front_mag_norm_min,back_mag_norm_min,front_mag_norm_max - front_mag_norm_min, \
//		                                                                back_mag_norm_max - back_mag_norm_min,front_mag_shake_trigger,back_mag_shake_trigger);
		
		if(t_count >= (3000/100))
		{
			if(front_mag_norm_max - front_mag_norm_min >= SELFCHECK_SENSOR_MAG_SHAKE_THRESHOLD && front_mag_shake_trigger)
			{
				ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_MAG_DATA_SHAKE);
			}
			
			if(back_mag_norm_max - back_mag_norm_min >= SELFCHECK_SENSOR_MAG_SHAKE_THRESHOLD && back_mag_shake_trigger)
			{
				ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_BACK_DATA_SHAKE);
			}
		}
	}
	
	//3ȡǰǷװ
	if(t_count == (3000/100) && ob_selfcheck.order == 0x52)
	{
		roll  = (int16_t)(Self_Front_Mahony.roll*100);
		if(roll < 0)roll *= -1;
		roll = (roll > 0 && roll < 100)?1:roll/100;
		
		if(!(roll >=SELFCHECK_MIDDLE_ACC_CONS_ROLL_MIN_THRESHOLD && roll <= SELFCHECK_MIDDLE_ACC_CONS_ROLL_MAX_THRESHOLD))
		{
			ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_FRONT_IMU_REVERSE);
		}
		
//		SEGGER_RTT_printf(0,"front roll:%d\r\n",roll);
	}

	//3鿴ܷȡ㲥֣СRSSIǷԼ
	if(t_count == (3000/100))
	{
		if(SELFCHECK_SCAN_DEVICE_RSSI_MIN_THRESHOLD >= ob_selfcheck.max_rssi)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_RSSI);
	}
	
	//3ر100𶯵Լ߳
	if(t_count == (3000/100))
	{
		Process_Stop(selfcheck_mt_process);
		Process_Stop(selfcheck_led_process);
		WS2812_DisplayDot(COLOR_BLACK);WS2812_Pwm_Play();
		nrf_gpio_pin_write(PIN_MT_EN,0);
	}

	//3+SELFCHECK_LED_DISPLAY_CYCLE_THRESHOLDʼԼʾ̣߳holdonȫС
	if(t_count == ((3000 + SELFCHECK_LED_DISPLAY_CYCLE_THRESHOLD)/100))
	{
		//Լõ
		if(ob_selfcheck.selfcheck_result == 0)
		{
			front_mag_norm = sqrt((double)(ob_selfcheck.f_data.mag[0]*ob_selfcheck.f_data.mag[0]) + (double)(ob_selfcheck.f_data.mag[1]*ob_selfcheck.f_data.mag[1]) + (double)(ob_selfcheck.f_data.mag[2]*ob_selfcheck.f_data.mag[2]));
			if(SELFCHECK_WEAR_INSOLE_MAG_NORM_MIN_THRESHOLD <= front_mag_norm)
			{
				ob_selfcheck.selfcheck_result_led_color = COLOR_GREEN;
				ob_selfcheck.selfcheck_result_flash_num = 1;
			}
			else
			{
				ob_selfcheck.selfcheck_result_led_color = COLOR_CYAN;
				ob_selfcheck.selfcheck_result_flash_num = 1;
			}	
		}
		else
		{
			ob_selfcheck.selfcheck_result_led_color = COLOR_RED;
			for(int i=0;i<sizeof(ob_selfcheck.selfcheck_result)*8;i++)
			{
				if((ob_selfcheck.selfcheck_result & (1 << i)) != 0)
				{
					ob_selfcheck.selfcheck_result_flash_num = i;
					break;
				}
			}	
		}
		Process_Start(SELFCHECK_LED_DISPLAY_CYCLE_THRESHOLD,"selfcheck_result_display_process",selfcheck_result_display_process);
		Process_SetHoldOn(selfcheck_result_display_process,1);
	}

	//ϱм䴫ļٶֵrollֵ
	L=0;
	int16_t rol  = (int16_t)(Mahony_M_GetRoll()*100);
	int16_t pitch = (int16_t)(Mahony_M_GetPitch()*100);
	int16_t yaw   = (int16_t)(Mahony_M_GetYaw()*100);
	buf[L++] = (uint8_t)(rol>>8);
	buf[L++] = (uint8_t)(rol>>0);
	buf[L++] = (uint8_t)(pitch>>8);
	buf[L++] = (uint8_t)(pitch>>0);
	buf[L++] = (uint8_t)(yaw>>8);
	buf[L++] = (uint8_t)(yaw>>0);
	buf[L++] = 0;
	buf[L++] = 0;
	buf[L++] = 0;
	buf[L++] = 0;
	buf[L++] = 0; 
	buf[L++] = 0;
	buf[L++] = 0;
	Mahony_send_ANO(0x01,buf,L);
	L=0;
	int32_t middle_acc_x = ob_selfcheck.m_data.acc[2];
	int32_t middle_acc_y = ob_selfcheck.m_data.acc[1];
	int16_t middle_acc_z = ob_selfcheck.m_data.acc[0];
	middle_acc_x *= 100;
	middle_acc_y *= 100;
	middle_acc_z *= 10;
	buf[L++] = (uint8_t)(middle_acc_x>>24);
	buf[L++] = (uint8_t)(middle_acc_x>>16);
	buf[L++] = (uint8_t)(middle_acc_x>>8);
	buf[L++] = (uint8_t)(middle_acc_x>>0);
	buf[L++] = (uint8_t)(middle_acc_y>>24);
	buf[L++] = (uint8_t)(middle_acc_y>>16);
	buf[L++] = (uint8_t)(middle_acc_y>>8);
	buf[L++] = (uint8_t)(middle_acc_y>>0);
	buf[L++] = (uint8_t)(middle_acc_z>>8);
	buf[L++] = (uint8_t)(middle_acc_z>>0);
	Mahony_send_ANO(0x07,buf,L);

	//ϱǰŴļٶݡݡشżƿƽ
	//ϱŴĵشżƿƽ
	//ϱɨ赽㲥rssiֵ
	if(TIME_GetTicks()-last_tim >= 1000)
	{
		last_tim = TIME_GetTicks();
		
		ob_selfcheck.max_rssi = -120;
	}
	L=0;
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.acc[0]>>8);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.acc[0]>>0);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.acc[1]>>8);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.acc[1]>>0);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.acc[2]>>8);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.acc[2]>>0);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.gry[0]>>8);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.gry[0]>>0);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.gry[1]>>8);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.gry[1]>>0);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.gry[2]>>8);
	buf[L++] = (uint8_t)(ob_selfcheck.f_data.gry[2]>>0);
	front_mag_norm = sqrt((double)(ob_selfcheck.f_data.mag[0]*ob_selfcheck.f_data.mag[0]) + (double)(ob_selfcheck.f_data.mag[1]*ob_selfcheck.f_data.mag[1]) + (double)(ob_selfcheck.f_data.mag[2]*ob_selfcheck.f_data.mag[2]));
	back_mag_norm = sqrt((double)(ob_selfcheck.b_data.mag[0]*ob_selfcheck.b_data.mag[0]) + (double)(ob_selfcheck.b_data.mag[1]*ob_selfcheck.b_data.mag[1]) + (double)(ob_selfcheck.b_data.mag[2]*ob_selfcheck.b_data.mag[2]));
	buf[L++] = (uint8_t)(front_mag_norm>>8);
	buf[L++] = (uint8_t)(front_mag_norm>>0);
	buf[L++] = (uint8_t)(back_mag_norm>>8);
	buf[L++] = (uint8_t)(back_mag_norm>>0);
	buf[L++] = (uint8_t)(ob_selfcheck.max_rssi>> 8);
	buf[L++] = (uint8_t)(ob_selfcheck.max_rssi>>0);
	Mahony_send_ANO(0x02,buf,L);
	
	fml_adc_get_value(PIN_CHARGING_CHANNEL,&adc_value);
	if(adc_value >= 2000)
	{
		if(continue_trigger <= 50)continue_trigger++;
	}
	else
	{
		if(continue_trigger != 0)continue_trigger--;
	}
	

//	SEGGER_RTT_printf(0,"continue_trigger:%d,%d\r\n",continue_trigger,adc_value);
//	SEGGER_RTT_printf(0,"front mag:%d,%d,%d,%d\r\n",ob_selfcheck.f_data.mag[0],ob_selfcheck.f_data.mag[1],ob_selfcheck.f_data.mag[2],front_mag_norm);
//	SEGGER_RTT_printf(0,"back mag:%d,%d,%d,%d\r\n",ob_selfcheck.b_data.mag[0],ob_selfcheck.b_data.mag[1],ob_selfcheck.b_data.mag[2],back_mag_norm);
					
	//30
	if(t_count >= (30000/100) && !slave_isconnect() && continue_trigger==0)
	{
    memset(mac_buf, 0, sizeof(mac_buf));
    sprintf(mac_buf, "%02X%02X%02X%02X%02X%02X", mFlash.macHost[0], mFlash.macHost[1], mFlash.macHost[2], mFlash.mClient.macAddr[3], mFlash.mClient.macAddr[4], mFlash.mClient.macAddr[5]);
		ST_scan_stop();
    host_set_scan_name(mac_buf, strlen(mac_buf));
		
		Flash_DeleteAllInfor();
		Flash_DeleteAllStep();
		Flash_DeleteAllBackup();
		
		//ָϢ
		memset(&mFlash,0xFF,sizeof(mFlash));
		memset(&mBackup,0xFF,sizeof(mBackup));
		
		//ݵflash
		if(Flash_SaveStep() != ZONE_OP_SUCCESS)Except_TxError(EXCEPT_Power,"save step fail");
		extern battercb_t battery_record;
//		extern void printbatter_cb(battercb_t *c,unsigned char *buff);
		memcpy(&mFlash.mbattercb_t,&battery_record,sizeof(battercb_t));
		mBackup.RestartCnt =0;
		if(Flash_SaveBackup() != ZONE_OP_SUCCESS)Except_TxError(EXCEPT_Power,"pwr save backup fail");
		if(Flash_SaveInfomation() != ZONE_OP_SUCCESS)Except_TxError(EXCEPT_Power,"pwr save information fail");
		NVIC_SystemReset();
	}
}

static void adc_callback(uint32_t sample_point, Fml_Adc_All_Channel_Adc_Value_t all_adc_value)
{
	//
}

/*API ------------------------------------------------------------------------------------------------------------------------------------*/
/**
	@brief 		Լ촥ص
	@param 		order							-	[in] صָ
	@return 	
*/
void selfcheck_trigger_callback(char order)
{
	int 							error;
	uint32_t					last_tim = TIME_GetTicks();
	
	//ι
	feed_watchdog();
	
	//ʼṹ壬ԼΪɹ
	memset(&ob_selfcheck,0,sizeof(ob_selfcheck));
	ob_selfcheck.max_rssi 											= -120;
	ob_selfcheck.selfcheck_result 							= SELFCHECK_RESULT_SUCCESS;
	ob_selfcheck.selfcheck_result_led_color			= COLOR_BLACK;
	ob_selfcheck.f_is_read_data									= false;
	ob_selfcheck.b_is_read_data									= false;
	ob_selfcheck.order													=	order;
	
	//ر̣߳ʼ0Լ̣߳holdonȫС
	Process_All_Stop();
	Process_Start(100,"selfcheck_process",selfcheck_process);	
	Process_SetHoldOn(selfcheck_process,1);

	//رɨ裬豸ɨصɨ
	while(TIME_GetTicks() - last_tim <= 1000)
	{
		host_disconnect();
		if(host_isconnect() == 0)break;
	}
	nrf_ble_scan_stop();
	host_set_scan_name((char *)"***********",sizeof("***********"));
	advdata_report_Evt_Regist(scan_report_cb);
	error = ST_scan_start();
	if(error != APP_SUCCESS)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_RSSI);

	//LEDԴΪSOD1
	nrf_gpio_cfg(
	PIN_LED_ENABLE,
	NRF_GPIO_PIN_DIR_OUTPUT,
	NRF_GPIO_PIN_INPUT_DISCONNECT,
	NRF_GPIO_PIN_NOPULL,
	NRF_GPIO_PIN_S0D1,
	NRF_GPIO_PIN_NOSENSE);

	//𶯵ΪSOS1
	nrf_gpio_cfg_output(PIN_MT_EN);
	nrf_gpio_pin_write(PIN_MT_EN,0);	
	
	//ledƵԴΪ
	nrf_gpio_pin_write(PIN_LED_ENABLE,LED_ENABLE);

	//³ʼADCͨ
	
	ADC_SetPinChannel(PIN_ADC_CHARGMEASURE, PIN_ADC_CHARGMEASURE_CHANNEL,NRF_GPIO_PIN_NOPULL);
	ADC_SetPinChannel(PIN_ADC_BAT_IN, PIN_ADC_BAT_CHANNEL,NRF_GPIO_PIN_NOPULL);
	ADC_SetPinChannel(PIN_CHARGING, PIN_CHARGING_CHANNEL,NRF_GPIO_PIN_NOPULL);
	fml_adc_sample_update_notify_register(adc_callback);

	//ǰŴм䴫Ŵ
	bll_imu_Init();
	bll_imu_register_data_notify_callback(BLL_IMU_DATA_NOTIFY_CB_PRIORITY_1, fb_data_notify_cb);
	bll_imu_Resume_config_param(&game_bll_imu_param_t);
	error = drv_qma_Init();
	if(error == -1)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_MIDDLE_SENSOR_CONFIG);
	nrf_delay_ms(20);
	error = drv_qma_set_acc_odr(QMA_ACC_ODR_104HZ);
	if(error == -1)ob_selfcheck.selfcheck_result |= (1 << SELFCHECK_RESULT_ERR_MIDDLE_SENSOR_CONFIG);
	
	//ʼ𶯵Լ߳
	Process_Start(0,"selfcheck_mt_process",selfcheck_mt_process);	
	Process_SetHoldOn(selfcheck_mt_process,1);
	
	//ʼLEDԼ߳
	Process_Start(SELFCHECK_LED_DISPLAY_CYCLE_THRESHOLD,"selfcheck_led_process",selfcheck_led_process);	
	Process_SetHoldOn(selfcheck_led_process,1);
	

	//ʼrollֵ㷨
	Mahony_Init(&Self_Mind_Mahony,104);
	
	Mahony_Init(&Self_Front_Mahony,416);
	
	//ι
	feed_watchdog();	
	
}















